function  varargout=plotiso(self,u,varargin)
  % plotoptions={'Color','w','LineWidth',2}
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('niso',10,@isscalar);
  %p.addParamValue('colormap','',@ischar);
  %p.addParamValue('colorbar',false,@islogical); % FC [04/01/2016] supprime-> appel externe
  p.addParamValue('color',[]); % unique color
  p.addParamValue('plan',false,@islogical);
  %p.addParamValue('PlotOptions',{},@iscell);
  p.addParamValue('isorange',[]);
  p.parse(varargin{:});
  R=p.Results;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  assert(  (self.d==2) && ismember(self.dim,[2,3]) )
  if (isempty(R.isorange) && R.niso>1), R.isorange=linspace(min(u),max(u),R.niso);end
  R.niso=length(R.isorange); 
  if length(u)==self.nqGlobal
    U=u(self.toGlobal);
  elseif length(u)==self.nqParent
    U=u(self.toParent);
  else  
    assert(length(u)==self.nq);
    U=u;
  end
  if size(U,1)==1, U=U';end
  [LS,LD,I] = fc_tools.graphics.gptoolbox.isolines(self.q',self.me',U,R.isorange);
%    if isempty(R.colormap)
%      colors = selectColors(R.niso);
%    else

  if isempty(R.color)
    cmap=colormap();%R.colormap);
    t=0:1/(R.niso-1):1;
    colors = fc_tools.graphics.RGB(t,cmap);
  else
    if size(R.color,1)==1
      if ischar(R.color), R.color = fc_tools.graphics.colorstr2rgb(R.color);end
      colors=ones(R.niso,1)*R.color;
    else
      assert( (size(R.color,1)==R.niso) && (size(R.color,2)==3) )
      colors=R.color;
    end
  end
  
  PrevHold=fc_tools.graphics.SetHoldOn(true);
  h=zeros(1,R.niso);
  for i=1:R.niso
    II=find(I==i);
    if isempty(II),h(i)=NaN;else
      %if fc_tools.comp.isOctave()
        N=length(II);
        X=[LS(II,1)';LD(II,1)';NaN(1, N)];Y=[LS(II,2)';LD(II,2)';NaN(1, N)];
        Faces=[1:N;N+1:2*N;1:N]';
        if self.dim==2
          if R.plan
            h(i)=plot(X(:),Y(:),'Tag',sprintf('isovalue : %g',R.isorange(i)),'color',colors(i,:),varargin{:});
          else
            Z=[R.isorange(i)*ones(2,N);NaN(1, N)];
            h(i)=plot3(X(:),Y(:),Z(:),'Tag',sprintf('isovalue : %g',R.isorange(i)),'color',colors(i,:),varargin{:});
          end
        else
          Z=[LS(II,3)';LD(II,3)';NaN(1, N)];
          h(i)=plot3(X(:),Y(:),Z(:),'Tag',sprintf('isovalue : %g',R.isorange(i)),'color',colors(i,:),varargin{:});
        end
%        else
%          X=[LS(II,1) LD(II,1)]';Y=[LS(II,2) LD(II,2)]';
%          if self.dim==2
%            if R.plan
%              h(i)=plot(X,Y,'Tag',sprintf('isovalue : %g',R.isorange(i)),'color',colors(i,:),varargin{:});
%            else
%              Z=R.isorange(i)*ones(2,size(II,1));
%              h(i)=plot3(X,Y,Z,'Tag',sprintf('isovalue : %g',R.isorange(i)),'color',colors(i,:),varargin{:});
%            end
%          else
%            Z=[LS(II,3) LD(II,3)];
%            h(i)=plot3(X,Y,Z,'Tag',sprintf('isovalue : %g',R.isorange(i)),'color',colors(i,:),varargin{:});
%          end
%        end
    end % if isempty(II) else
  end
  if nargout>=1, varargout{1}=colors;end
  if nargout>=2, varargout{2}=R.isorange;end
  if nargout==3, varargout{3}=h;end
  fc_tools.graphics.RestoreHold(PrevHold)
end

